require "sticky/version"
require "sticky/note"
require "thor"

module Sticky
  class CLI < Thor

    desc "new MESSAGE", "Creates a new sticky note."
    option :tag, type: :string, aliases: :t
    def new(message)
      Sticky::Note.build(message, options[:tag]).save!
    end

    desc "show", "Displays sticky notes."
    long_desc <<-LONGDESC
    Use `-t my-tag` or `-d YYYY-MM-DD` to display matching tags.
    LONGDESC
    option :tag,  type: :string, aliases: :t
    option :date, type: :string, aliases: :d
    def show
      date = options[:date] ? Time.parse(options[:date]) : nil
      Sticky::Note.show(options[:tag], date)
    end

    desc "delete", "Deletes sticky notes tagged with TAG."
    option :tag, type: :string, aliases: :t, required: true
    def delete
      Sticky::Note.delete!(options[:tag])
    end
  end
end
