module Sticky
  class Config

    def initialize
      @config = {
        store: "YAML::Store",
        sticky_path: File.join(Dir.home, ".sticky.yml")
      }.merge(config_overrides)
    end

    def fetch(key)
      @config[key]
    end

    private

    def config_overrides
      YAML.load(config_file).tap do |yaml|
        yaml.keys.each do |key|
          yaml[key.to_sym] = yaml.delete(key)
        end
      end
    end

    def config_file
      File.exists?(config_path) ? File.open(config_path) : "{}"
    end

    def config_path
      File.join(Dir.home, ".sticky.config")
    end
  end
end
