require "sticky/store"

module Sticky
  class Note
    attr_accessor :message, :tag, :timestamp, :db

    class << self
      def build(message, tag = nil, db = Sticky::Store.new)
        new(message, tag, db)
      end

      def show(tag, date, db = Sticky::Store.new)
        db.fetch(tag, date) do |note|
          puts "#{note.timestamp} #{note.message}"
        end
      end

      def delete!(tag, db = Sticky::Store.new)
        db.delete!(tag)
      end
    end

    def initialize(message, tag, db, timestamp = Time.now)
      @message = message
      @db = db
      @tag = tag
      @timestamp = timestamp
    end

    def save!
      db.save!(self)
    end

    def to_yaml_properties
      [:@message, :@tag, :@timestamp]
    end
  end
end
