require "yaml/store"
require "sticky/config"

module Sticky
  class Store
    attr_reader :store

    def initialize(config = Sticky::Config.new)
      klass = Object.const_get(config.fetch(:store))
      @store = klass.new(config.fetch(:sticky_path))
    end

    def fetch(tag = nil, date = nil)
      # FIXME: this is ugly, refactor this
      store.transaction do
        store[:sticky_notes] || []
        store[:sticky_notes].each do |sticky|
          if block_given? && ((tag.nil? && date.nil?) \
              || tag == sticky.tag \
              || date&.to_date == sticky.timestamp&.to_date)
            yield sticky
          end
        end
      end
    end

    def delete!(tag)
      if tag
        store.transaction do
          store[:sticky_notes] || []
          store[:sticky_notes].reject! { |sticky| sticky.tag == tag }
        end
      end
    end

    def save!(sticky)
      store.transaction do
        store[:sticky_notes] ||= []
        store[:sticky_notes] << sticky
      end
    end
  end
end
